每日一题
两数之和问题
给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6
输出:[0,1]
提示:
2 <= nums.length <= 103
-109 <= nums[i] <= 109
-109 <= target <= 109
只会存在一个有效答案
- 暴力求解法
public int[] twoSum(int[] nums, int target) {
int n = nums.length;//定义数组
for(int i =0;i<n-1;i++){//定义加数1
for(int j = i+1;j<n;j++){//定义加数2
if(nums[i] + nums[j] == target){//如果加数和等于target
return new int[]{i,j};//输出
}
}
}
throw new IllegalArgumentException("NO tow sum solution");//报错处理
}
这种情况虽然能解决问题,但不能合理利用资源
时间复杂度:O(
n
2
n^{2}
n2),n为数组长度。最坏情况下数组中任意两个数都要被匹配一次。
空间复杂度:O(1),常数为临时变量个数。
方法二:以空间换时间
查找表法
使用哈希表,可以将寻找 target - x 的时间复杂度降低到从 O(N)O(N) 降低到 O(1)O(1)。
这样我们创建一个哈希表,对于每一个 x,我们首先查询哈希表中是否存在 target - x,然后将 x 插入到哈希表中,即可保证不会让 x 和自己匹配。
import java.util.HashMap;
import java.util.Map;
class Solution {
public int[] twoSum(int[] nums, int target) {
int n = nums.length;//定义数组
Map<Integer,Integer> hashMap = new HashMap<>(n - 1);//初始hash表为数组个数
hashMap.put(nums[0],0);//第一没有与之对立的直接存入表内
for(int i =1;i<n;i++){//从下标为1的开始遍历
int another = target - nums[i];
if(hashMap.containsKey(another)){
return new int[]{i,hashMap.get(another)};
}
hashMap.put(nums[i],i);
}
throw new IllegalArgumentException("NO tow sum solution");
}
}
来源:力扣(LeetCode)